from django.db.models import Q

from inspect_report.models import Team, Country


def get_team_names(city_id, country_id):
    # # 获取坐席团队关系
    team_names = list()
    if city_id and country_id:
        team_names = Team.objects.filter(country_id=country_id).values_list('name')
    elif city_id and (country_id is None or country_id == ''):
        city = Country.objects.filter(id=city_id).first()
        if city.parent is None:
            team_names = Team.objects.filter().values_list('name')
        else:
            country_id_list = Country.objects.filter(Q(parent=city_id) | Q(id=city_id)).values_list('id')
            team_names = Team.objects.filter(country_id__in=country_id_list).values_list('name')
    return team_names


def get_country_names(city_id):
    city = Country.objects.filter(id=city_id).first()
    if city.parent is None:
        return None
    else:
        return city.name
