from rest_framework import viewsets
from rest_framework.decorators import action
from rest_framework.request import Request
from rest_framework.response import Response

from before_request import before_request
from inspect_report.models import Country, Team


class AgencyApi(viewsets.ViewSet):
    authentication_classes = ()
    permission_classes = ()

    # permission_classes = (permissions.ValidateToken, )

    @action(['get'], detail=False)
    @before_request
    def city(self, req: Request):
        """
        加载城市列表
        :param req:
        :return:
        """
        username = req.data.get('username', '')
        city_list = list()
        country_list = list()
        top = Country.objects.filter(name=username).first()
        if top is not None:
            if top.parent is None:
                cities = Country.objects.filter(parent=top.id).all()
            else:
                cities = None
            city_id = top.id
        else:
            top = Country.objects.filter(parent=None).first()
            cities = Country.objects.filter(parent=top.id).all()
            city_id = top.id

        if cities is not None:

            city_list.append({'id': top.id, 'name': top.name})

            for city in cities:
                city_list.append({'id': city.id, 'name': city.name})

        else:
            city_list.append({'id': top.id, 'name': top.name})
            countries = Country.objects.filter(parent=top.id).all()

            if len(countries) > 0:
                for country in countries:
                    if len(Team.objects.filter(country=country.id).all()) > 0:
                        country_list.append({'id': country.id, 'name': country.name})

        return_data = {'city_list': city_list, 'country_list': country_list, 'city_id': city_id}

        return Response({'code': 0, 'msg': 'success', 'data': return_data})

    @action(['get'], detail=False)
    def country(self, req: Request):
        """
        查询任务列表
        :param req:
        :return:
        """
        city_id = req.GET.get('city_id', '')
        country_list = list()
        top = Country.objects.filter(id=city_id).first()
        if top is not None:
            if top.parent is None:
                pass
            else:
                countries = Country.objects.filter(parent=city_id).all()
                for country in countries:
                    if len(Team.objects.filter(country=country.id).all()) > 0:
                        country_list.append({'id': country.id, 'name': country.name})
            return Response({'code': 0, 'msg': 'success', 'data': {'country_list': country_list}})
        else:
            return Response({'code': -1, 'msg': '未找到对应的县市'})
